// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Outbar2_demo.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);


// here we start with the outbar control stuff

//	enable dockings only on the other 3 sides
	EnableDocking(CBRS_ALIGN_TOP | CBRS_ALIGN_BOTTOM | CBRS_ALIGN_RIGHT);

	// create the control
	wndOutBar.Create(this, 100);
	
	// you can add images to the items in the control by using icons 16x16
	HICON hIco1 = (HICON) LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_ICON1),IMAGE_ICON,16,16,0);
	HICON hIco2 = (HICON) LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_ICON2),IMAGE_ICON,16,16,0);
	HICON hIco3 = (HICON) LoadImage(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDI_ICON3),IMAGE_ICON,16,16,0);

	// The items are stored in a tree-like way
	// We have:
	// Folder 1 ------	Item 1.1 ----	SubItem 1.1.1
	//		+				+--------	SubItem 1.1.2
	//		+				+--------	SubItem 1.1.3
	//		+
	//		+---------	Item 1.2 ----	SubItem 1.2.1
	//						+--------	SubItem 1.2.2
	
	// We can have many folders. Each folder contains an item - which is usually
	// a sort of header - subtitle - separator. Each item contains subitems, that
	// are what we in effect use. The subitems are basically menu' items/toolbar 
	// buttons commands handlers. They rely on the standard MFC command update
	// system for the effects.

	// int AddFolder(const char * FolderName, HICON ImageofFolder or int ResourceIdofFolderIcon);
	//	+ returns the id of the folder

    // int AddFolderItem(const char * ItemName, int FolderID = -1)
	// + returns the ID of the item. Takes in the name of the item (or Null if you want a simple separator) and the folder id where it has to be inserted (or -1 or USE_LAST_INSERT for last folder)

	// int AddSubItem(const char * SubItemLabel, HICON ImageofFolder or int ResourceIdofFolderIcon, DWORD style, DWORD commandID, int FolderId, int ItemId)
	// + returns the ID of the subitem. Takes in the display name of the subitem, the icon id or handle (or NULL), the style of subitem (see below), the ID of command to be used when user clicks on it, and the folder and item id
	//   style can assume the following values:
	//	 COutlook2Ctrl::OCL_SELECT		the subitem will appear as a selected listbox item when the OnCmdUI of the commandID returns Checked
	//	 COutlook2Ctrl::OCL_RADIO		the subitem will appear as a radio button; status will be determined by the checked/unchecked of the associated commandID; no command will be sent when user clicks on a already selected item
	//	 COutlook2Ctrl::OCL_COMMAND		the subitem will appear as a normal hottracked link. The commandID command will be sent whenever user clicks on it, unless the OnCmdUI returns not enabled
	//	 COutlook2Ctrl::OCL_CHECK		the subitem will appear as a check box; status will be determined by the checked/unchecked of the associated commandID; no command will be sent when user clicks on a already selected item
	//	 COutlook2Ctrl::OCL_HWND		this value is settled automatically when using the following function:

	// int AddSubItem(HWND hChildWindow, bool bStretchTheChild, int FolderId, int ItemId)
	// + returns the ID of the subitem. Takes in the child window to insert, a stretch option value and the folder and item id.
	//   The child window has to be already created when inserted. It has to have as parent the outbar control, and the WS_CHILD flag.
	//   If the stretch variable isn't settled, the child will retain the value it had at creation;
	//	 otherwise, the height of the child window will be enlarged to fit all the area from insertion to the bottom of control.
	//	 The child window will anyway always be stretched to cover all the width of the outbar control.

	wndOutBar.AddFolderRes("Contacts", IDI_ICON1);
		wndOutBar.AddFolderItem("Categories");
			wndOutBar.AddSubItem("Friends", hIco1, COutlook2Ctrl::OCL_SELECT, ID_CATEGORIES_FRIEND);
			wndOutBar.AddSubItem("Private", hIco2, COutlook2Ctrl::OCL_SELECT, ID_CATEGORIES_PRIVATE);
			wndOutBar.AddSubItem("Work", hIco3, COutlook2Ctrl::OCL_SELECT, ID_CATEGORIES_WORK);

		wndOutBar.AddFolderItem("View Style");
			wndOutBar.AddSubItem("Grid", NULL, COutlook2Ctrl::OCL_RADIO, ID_VIEW_GRID);
			wndOutBar.AddSubItem("List", NULL, COutlook2Ctrl::OCL_RADIO, ID_VIEW_LIST);
			wndOutBar.AddSubItem("Cards", NULL, COutlook2Ctrl::OCL_RADIO, ID_VIEW_CARDS);

		wndOutBar.AddFolderItem("");
			wndOutBar.AddSubItem("Name", NULL, COutlook2Ctrl::OCL_CHECK, ID_FIELDS_NAME);
			wndOutBar.AddSubItem("Phone", NULL, COutlook2Ctrl::OCL_CHECK, ID_FIELDS_PHONE);
			wndOutBar.AddSubItem("Address", NULL, COutlook2Ctrl::OCL_CHECK, ID_FIELDS_ADDRESS);

		wndOutBar.AddFolderItem("");
			wndOutBar.AddSubItem("Create new contact ..", NULL, COutlook2Ctrl::OCL_COMMAND, ID_TEST_CREATENEWCONTACT);
			wndOutBar.AddSubItem("Import contacts ..", NULL, COutlook2Ctrl::OCL_COMMAND, ID_TEST_IMPORTCONTACT);

// here we insert the dialog test page as a child
	dlgSubPage1.Create(CDlgTest1::IDD, &wndOutBar);

	wndOutBar.AddFolderRes("Find", IDI_ICON2);
		wndOutBar.AddFolderItem("Find items");
			wndOutBar.AddSubItem(dlgSubPage1.GetSafeHwnd(), true);

	wndOutBar.AddFolderRes("Dummy Folder", IDI_ICON3);

	EnableDocking (CBRS_ALIGN_LEFT);
	DockControlBar(&m_wndToolBar);


	HICON hMainIco = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hMainIco, TRUE);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers

void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
